""" Upgrade Patch to Product Version 1.1.x for ExtFile/ExtImage Product 
    Patch Version 2.1

    External method for recursively searching the object-tree
    for ExtFile/ExtImage objects and apply a patch
"""

from Products.ExtFile.ExtFile import __version__
from DateTime import DateTime
import os, types, time, string

#ExtFileObjects = ['ExtFile', 'ExtImage', 'ExtFile_CMF', 'ExtImage_CMF', 'ExtDocument']
ExtFileObjects = ['ExtFile', 'ExtImage']

def patch(self, obj=None, path=''):
    if string.find(__version__, '1.1.')!=0:
        return '<html><head></head><body><h3>No need to patch. Please upgrade'+\
               'to Version 1.1.x first!</h3></body></html>'
    ret=''
    if obj==None: 
        obj=self
        first=1
    else:
        first=0
    if hasattr(obj, 'aq_base'): obj=obj.aq_base
    if obj.meta_type in ExtFileObjects:
        try: 
            res=apply_patch(obj)
        except: 
            res='Exception-Error'
        if res=='': ret='%s --> OK<br>' % path
        else: ret='%s --> <b>%s</b><br>' % (path, res)
    elif hasattr(obj, '_objects'):
        for d in obj._objects:
            o=getattr(obj,d['id'])
            ret=ret+patch(self,o, path+'/'+d['id'])
    if first: ret='<html><head></head><body><h3>Product Version: '+ \
                  __version__+'</h3><h3>The following objects were checked '+ \
                  'and patched:</h3>'+ret+'</body></html>'
    return ret

def apply_patch(self):
    ret=''
    if string.find(__version__, '1.1.0.beta')!=0:
        if hasattr(self, 'filename') and type(self.filename)!=types.ListType:
            self.filename=[self.filename]
        if hasattr(self, 'prev_filename') and \
           type(self.prev_filename)!=types.ListType:
            self.prev_filename=[self.prev_filename]

    if hasattr(self, 'has_preview') and self.has_preview and \
       hasattr(self, 'prev_filename') and hasattr(self, 'filename') and \
       self.filename!=self.prev_filename:
        if string.find(__version__, '1.1.0.beta')!=0:
	        file=self._get_filename(self.prev_filename)
        else:
            file=os.path.join(self._reposit_path(), self.prev_filename)
        if os.path.exists(file):
            os.utime(file,(time.time(),time.time()))
        elif os.path.exists(file+'.undo'):
            os.rename(file+'.undo',file)
            os.utime(file,(time.time(),time.time()))
        else:
            ret=" - Preview not found %s" % self.prev_filename
    
    if hasattr(self, 'filename'):
        if string.find(__version__, '1.1.0.beta')!=0:
            file=self._get_filename(self.filename)
        else:
            file=os.path.join(self._reposit_path(), self.filename)
        if os.path.exists(file):
            os.utime(file,(time.time(),time.time()))
        elif os.path.exists(file+'.undo'):
            os.rename(file+'.undo',file)
            os.utime(file,(time.time(),time.time()))
        else:
            ret="%s - File not found %s" % (ret, self.filename)
    
    if not hasattr(self, 'title'): self.title=''
    if not hasattr(self, 'descr'): self.descr=''
    self.__version__=__version__
    try:  delattr(self, 'width')
    except: pass
    try: delattr(self, 'height')
    except: pass
    try: delattr(self, 'size')
    except: pass
    try: delattr(self, 'rawsize')
    except: pass
    try: delattr(self, 'prev_width')
    except: pass
    try: delattr(self, 'prev_height')
    except: pass
    try: delattr(self, 'prev_size')
    except: pass
    try: delattr(self, 'prev_rawsize')
    except: pass
    try: delattr(self, 'format')
    except: pass
    return ret
